/* 
                    |-------------------------|
                    | PROGRAM NAME: UnionJack.C  
                    |                         |
                    |  Copyright: xxxx   |
-------------------------------------------------------------------------------
 
*/

/*double usr_parameter(int bonds, double alpha)
{
  // condition for triangular AF in external field: both model states
    if (bonds==1 || bonds==2) return alpha;
      return 1.0;
}*/

double usr_angle(int bonds, int term13, double *alpha, int numalpha)
{

  double mult = 0.0;  // default for term13 = {10,11,12,13}
  
  if (bonds==1) {   // J2 bit now...
    // delta term
    // here it's J2 parameter model for the Union Jack model
    // now the J2 part
    if      (term13 == 1) mult=      cos(2*alpha[0]);       // s^z s^z 
    else if (term13 == 2) mult= -0.5*sin(2*alpha[0]);       // s^z s^+ 
    else if (term13 == 3) mult= -0.5*sin(2*alpha[0]);       // s^z s^- 
    else if (term13 == 4) mult=  0.5*sin(2*alpha[0]);       // s^+ s^z
    else if (term13 == 5) mult=  0.5*sin(2*alpha[0]);       // s^- s^z
    else if (term13 == 6) mult= 0.25*(1.0+cos(2*alpha[0])); // s^+ s^-
    else if (term13 == 7) mult= 0.25*(1.0+cos(2*alpha[0])); // s^- s^+
    else if (term13 == 8) mult= 0.25*(cos(2*alpha[0])-1); // s^+ s^+
    else if (term13 == 9) mult= 0.25*(cos(2*alpha[0])-1);  // s^- s^-
  } else  {   // J1 bit now... J=1
    if      (term13 == 1) mult=      -cos(alpha[0]); // Oct05: -cos 
    else if (term13 == 2) mult=  -0.5*sin(alpha[0]);
    else if (term13 == 3) mult=  -0.5*sin(alpha[0]);
    else if (term13 == 4) mult=   0.5*sin(alpha[0]);
    else if (term13 == 5) mult=   0.5*sin(alpha[0]);
    else if (term13 == 6) mult= 0.25*(1.0-cos(alpha[0]));
    else if (term13 == 7) mult= 0.25*(1.0-cos(alpha[0]));
    else if (term13 == 8) mult= -0.25*(cos(alpha[0])+1);
    else if (term13 == 9) mult= -0.25*(cos(alpha[0])+1);
  }
  return mult;
}
